using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;

namespace CopsAndRobbers
{
    class Sprite : BaseGame
    {
        protected Color mColor = Color.White;
        protected Rectangle mDestination;

        public Sprite(Vector2 thePosition, int theWidth, int theHeight, Color theColor)
        {
            mDestination = new Rectangle((int)thePosition.X, (int)thePosition.Y, theWidth, theHeight);
            mCollisionRectangle = new Rectangle(mDestination.X, mDestination.Y, theWidth, theHeight);
            mColor = theColor;
        }

        //Store the collision box for the sprite
        protected Rectangle mCollisionRectangle;
        public virtual Rectangle CollisionRectangle
        {
            get { return mCollisionRectangle; }
        }
       
        //Determines if the Hitbox (collision rectangle)
        //is visible for testing purposes
        bool mDrawHitBox = false;
        public bool HitBoxVisible
        {
            get { return mDrawHitBox; }
            set { mDrawHitBox = value; }
        }

        public virtual void Draw()
        {
            //If the Hitbox is visible, then draw it
            if (mDrawHitBox == true)
            {
                mBatch.Draw(Texture.Wall, mCollisionRectangle, Color.BlanchedAlmond);
            }
        }
    }
}
