using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;

namespace CopsAndRobbers
{
    class CopCar : Car
    {
        //Define the Car's height
        const int Car_Height = 200;

        //Define the length of time the Siren is displayed/not displayed
        const double Siren_DisplayDefault = 200;

        //Define the X and Y offsets for where the siren
        //is drawn in relation to the Car's position
        const int Siren_XOffset = 195;
        const int Siren_YOffset = 30;

        //Define the rectangular shape in the image
        //where the siren flash is located
        const int Siren_X = 200;
        const int Siren_Y = 420;
        const int Siren_Width = 71;
        const int Siren_Height = 62;
        
        double mSirenLightDisplay = Siren_DisplayDefault;
        bool mDisplayLight = true;

        public CopCar(double theScale) : base(theScale)        
        {
            //Create the rectangle shape to be selected from the texture object
            SourceRectangle = new Rectangle(0, 0, Texture.Car.Width, Car_Height);
            Effects = SpriteEffects.FlipHorizontally;
            mCarType = CarType.Cop;
        }

        public override void DrawExtraCarPieces(Rectangle theCarRectangle, SpriteBatch theBatch, GameTime theGameTime, Texture2D theCarTexture)
        {           
            //Subtract the displayed/not displayed time to determine when
            //to "flash" the siren light
            mSirenLightDisplay -= theGameTime.ElapsedGameTime.Milliseconds;
            if (mSirenLightDisplay < 0)
            {
                mDisplayLight = !mDisplayLight;
                mSirenLightDisplay = Siren_DisplayDefault;
            }

            //Draw the Siren light when appropriate
            if (mDisplayLight == true)
            {
                Rectangle aSirenLight = new Rectangle(theCarRectangle.X + (int)(Siren_XOffset * mScale), theCarRectangle.Y - (int)(Siren_YOffset * mScale), (int)(Siren_Width * mScale), (int)(Siren_Height * mScale));            
                theBatch.Draw(theCarTexture, aSirenLight, new Rectangle(Siren_X, Siren_Y, Siren_Width, Siren_Height), Color.White, 0, new Vector2(0, 0), SpriteEffects.None, 0);
            }
        }
    }
}
