using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;

namespace CopsAndRobbers
{
    class RobberCar : Car
    {
        //Define the position of the Robber image in the source texture
        const int Texture_X = 0;
        const int Texture_Y = 200;
        const int Texture_Height = 210;

        //Define the size of the image
        const int Robber_Width = 363;
        const int Robber_Height = 210;

        //Define the offests and size of the Robber tires
        const int TireOne_XOffset = 110;
        const int TireOne_YOffset = 170;
        const int TireTwo_XOffset = 235;
        const int TireTwo_YOffset = 170;
        const int Tire_Width = 72;
        const int Tire_Height = 72;

        public RobberCar(double theScale)
            : base(theScale) 
        {
            SourceRectangle = new Rectangle(Texture_X, Texture_Y, Texture.Car.Width, Texture_Height);
            mCarType = CarType.Robber;
        }

        protected override void MoveCar(double theMovementX, double theMovementY, GameTime theGameTime)
        {
            theMovementX *= theGameTime.ElapsedGameTime.Milliseconds;
            theMovementY *= theGameTime.ElapsedGameTime.Milliseconds;

            mCarRectangle = new Rectangle(mCarRectangle.X + (int)theMovementX, mCarRectangle.Y + (int)theMovementY, (int)(Robber_Width * mScale), (int)(Robber_Height * mScale));
        }

        protected override void UpdateCar()
        {
            aCarRectangle = new Rectangle(0, 0, (int)(Robber_Width * mScale), (int)(Robber_Height * mScale)); 
            aTireOneRectangle = new Rectangle(aCarRectangle.X + (int)(TireOne_XOffset * mScale), aCarRectangle.Y + (int)(TireOne_YOffset * mScale), (int)(Tire_Width * mScale), (int)(Tire_Height * mScale));
            aTireTwoRectangle = new Rectangle(aCarRectangle.X + (int)(TireTwo_XOffset * mScale), aCarRectangle.Y + (int)(TireTwo_YOffset * mScale), (int)(Tire_Width * mScale), (int)(Tire_Height * mScale));
        }        
    }
}
